#ifndef COMPRESS_H
#define COMPRESS_H

// its soooo ugly...

#include <zlib.h>
#include <assert.h>

#include <util.h>
#include <string.h>

#include "protocol.h"

#define BUFFER_SAFETY 1000
#define BUFFSIZE (MAX_PACKET+12+(MAX_PACKET/1000+1)+BUFFER_SAFETY)

class zlib_stream : protected z_stream {
protected:
  u8 b_out[BUFFSIZE];
  
  zlib_stream () { zalloc = Z_NULL; zfree = Z_NULL; opaque = Z_NULL; };
  void reset_buf () { next_out = b_out; avail_out = BUFFSIZE; };
};

class compressor : zlib_stream {
public:
  compressor () { assert (deflateInit (this, 9) == Z_OK); reset_buf (); };
  ~compressor () { deflateEnd (this); };
  unsigned long total () { return total_out; };
  
  void put (u8 b)
    {
      next_in = &b;
      avail_in = 1;
      assert (deflate (this, Z_NO_FLUSH) == Z_OK);
    };
  
  int avail (int want)
    {
      if (next_out - b_out < want)
        deflate (this, Z_SYNC_FLUSH);
      
      return next_out - b_out;
    };
  
  u8 get ()
    {
      u8 ret = b_out[0];
      
      next_out--, avail_out++;
      memcpy (b_out, b_out + 1, next_out - b_out);
      return ret;
    }
};

class decompressor : zlib_stream {
public:
  decompressor () { assert (inflateInit (this) == Z_OK); reset_buf (); };
  ~decompressor () { inflateEnd (this); };
  unsigned long total () { return total_in; };
  
  void put (u8 b)
    {
      next_in = &b;
      avail_in = 1;
      assert (inflate (this, Z_SYNC_FLUSH) == Z_OK);
    };
  
  int avail ()
    {
      return next_out - b_out;
    };
  
  u8 *get_buf ()
    {
      reset_buf ();
      return b_out;
    };
};

#endif

